-- Coded by: Exzu / EU-Aszune


textDatabase = {
	ANT = { fontSize = "14", loc = "TOP", x = 0, y = 8, color = {1, 1, 1, 1}, text = "Satchel Scanner", },
	statusText = { fontSize = "16", loc = "LEFT", x = 5, y = 82, color = {0, 1, 0, 1}, text = "Current Status:", },
	scanText = { fontSize = "16", loc = "LEFT", x = 95, y = 82, color = {1, 0, 0, 1}, text = "Not Running", },
	tankText = { fontSize = "14", loc = "LEFT", x = 22, y = 65, color = {1, 1, 1, 1}, text = "Tank:", },
	tankScanningText = { fontSize = "14", loc = "LEFT", x = 52, y = 65, color = {1, 0, 0, 1}, text = "Not Scanning...", },
	tankdg1 = { fontSize = "14", loc = "LEFT", x = 6, y = 50, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	tankdg2 = { fontSize = "14", loc = "LEFT", x = 6, y = 35, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	healerText = { fontSize = "14", loc = "LEFT", x = 22, y = 20, color = {1, 1, 1, 1}, text = "Healer:", },
	healScanningText = { fontSize = "14", loc = "LEFT", x = 62, y = 20, color = {1, 0, 0, 1}, text = "Not Scanning...", },
	healdg1 = { fontSize = "14", loc = "LEFT", x = 6, y = 5, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	healdg2 = { fontSize = "14", loc = "LEFT", x = 6, y = -10, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	dpsText = { fontSize = "14", loc = "LEFT", x = 22, y = -25, color = {1, 1, 1, 1}, text = "DPS:", },
	dpsScanningText = { fontSize = "14", loc = "LEFT", x = 47, y = -25, color = {1, 0, 0, 1}, text = "Not Scanning...", },
	dpsdg1 = { fontSize = "14", loc = "LEFT", x = 6, y = -40, color = {0, 0.6, 0.8, 1}, text = "# ...", },
	dpsdg2 = { fontSize = "14", loc = "LEFT", x = 6, y = -55, color = {0, 0.6, 0.8, 1}, text = "# ...", },
};


frameDatabase = {
	scanButton = { Type = "Button", inherit = "UIPanelButtonTemplate", width = "80", height = "25", loc = "BOTTOM", x = -80, y = 5, text = "Start", script = true, functionName = "startScanning()", },
	stopButton = { Type = "Button", inherit = "UIPanelButtonTemplate", width = "80", height = "25", loc = "BOTTOM", x = 80, y = 5, text = "Stop", script = true, functionName = "stopScanning()", },
	closeButton = { Type = "Button", inherit = "UIPanelButtonTemplate", width = "20", height = "20", loc = "TOP", x = 112, y = -5, text = "X", script = true, functionName = "MainFrame:Hide()", },
	configButton = { Type = "Button", inherit = "UIPanelButtonTemplate", width = "60", height = "25", loc = "BOTTOM", x = 0, y = 5, text = "Config", script = true, functionName = "InterfaceOptionsFrame_OpenToCategory(SatchelScanner.childpanel)", },
	tankIcon = { texture = true, name = "Tank Icon", Type = "Frame", width = "15", height = "15", loc = "LEFT", x = 6, y = 65, location = "Interface\\Addons\\SatchelScanner\\icons\\tankIcon.tga", },
	healIcon = { texture = true, name = "Healer Icon", Type = "Frame", width = "15", height = "15", loc = "LEFT", x = 6, y = 20, location = "Interface\\Addons\\SatchelScanner\\icons\\healerIcon.tga", },
	dpsIcon = { texture = true, name = "Dps Icon", Type = "Frame", width = "15", height = "15", loc = "LEFT", x = 6, y = -25, location = "Interface\\Addons\\SatchelScanner\\icons\\dpsIcon.tga", },
};


-- Variables
local playSound = true;
local UpdateInterval = 3.0;
local running = false;
local scanForTank = true;
local scanForHeal = true;
local scanForDps = false;
local runVar = {"Not Running", "Running"};
local addonVersion = "1.9.0";
local satchelFound = false;

-- Dungeon Scan Var
local heroicVar = {"# Hour of Twilight Heroic!", "# Cataclysm Heroic!"};
local scanVar = {"# ...", "# Searching..."};
local classScan = {"Not Scanning...","Scanning...","Satchel Found!"};
local ctaVar = {"Call to Arms: Tank","Call to Arms: Healer","Call to Arms: Dps"};


-- Addon Colors
--local colors = { red = {1,0,0,1}, green = {0,1,0,1}, yellow = {1,1,0,1}, } -- To be used in an upcoming table
local redColor = {1,0,0,1};
local greenColor = {0,1,0,1};
local yellowColor = {1,1,0,1};

function stopScanning()
	if running then
		playSound = false
		satchelFound = false
		running = false
		textDatabase.scanText.textFrame:SetTextColor(unpack(redColor));
		textDatabase.scanText.textFrame:SetText(runVar[1]);
		textDatabase.tankScanningText.textFrame:SetText(classScan[1]);
		textDatabase.tankScanningText.textFrame:SetTextColor(unpack(redColor));
		textDatabase.healScanningText.textFrame:SetText(classScan[1]);
		textDatabase.healScanningText.textFrame:SetTextColor(unpack(redColor));
		textDatabase.dpsScanningText.textFrame:SetText(classScan[1]);
		textDatabase.dpsScanningText.textFrame:SetTextColor(unpack(redColor));
		textDatabase.tankdg1.textFrame:SetText(scanVar[1]);
		textDatabase.tankdg2.textFrame:SetText(scanVar[1]);
		textDatabase.healdg1.textFrame:SetText(scanVar[1]);
		textDatabase.healdg2.textFrame:SetText(scanVar[1]);
		textDatabase.dpsdg1.textFrame:SetText(scanVar[1]);
		textDatabase.dpsdg2.textFrame:SetText(scanVar[1]);
	end
end

function startScanning()
	if not running and (scanForTank or scanForHeal or scanForDps) then
		running = true
		playSound = true
		textDatabase.scanText.textFrame:SetTextColor(unpack(greenColor));
		textDatabase.scanText.textFrame:SetText(runVar[2]);
		if scanForTank then
			textDatabase.tankdg1.textFrame:SetText(scanVar[2]);
			textDatabase.tankdg2.textFrame:SetText(scanVar[2]);
		end
		if scanForHeal then
			textDatabase.healdg1.textFrame:SetText(scanVar[2]);
			textDatabase.healdg2.textFrame:SetText(scanVar[2]);
		end
		if scanForDps then
			textDatabase.dpsdg1.textFrame:SetText(scanVar[2]);
			textDatabase.dpsdg2.textFrame:SetText(scanVar[2]);
		end
		RequestLFDPlayerLockInfo();
	elseif not running and not (scanForTank or scanForHeal or scanForDps) then
		print("Must scan for atleast one class before starting the program!");
	end
end

-- Database values
function createConfig()
	SatchelScannerDB = {}
	dbAdd("updateint", 3);
	dbAdd("sounds", true);
	dbAdd("version", addonVersion);
	dbAdd("scanTank", true);
	dbAdd("scanHeal", true);
	dbAdd("scanDps", false);
	readConfig();
end

function readConfig() -- Reads values from DB
	if not SatchelScannerDB then
		createConfig();
	else
		playSound = SatchelScannerDB["sounds"];
		UpdateInterval = SatchelScannerDB["updateint"];
		dbVersion = SatchelScannerDB["version"];
		scanForTank = SatchelScannerDB["scanTank"]
		scanForTankButton:SetChecked(scanForTank)
		scanForHeal = SatchelScannerDB["scanHeal"]
		scanForHealButton:SetChecked(scanForHeal)
		scanForDps = SatchelScannerDB["scanDps"]
		scanForDpsButton:SetChecked(scanForDps)
	end	
end

function dbAdd(var, arg) -- Updates values in db
	SatchelScannerDB[var] = arg;
end

-- Scanner - DO NOT MODIFY!
function satchelFinder(role, id)
		local eligible, forTank, forHealer, forDamage, itemCount, money, xp = GetLFGRoleShortageRewards(id, 1)
		if (itemCount ~= 0 or money ~= 0 or xp ~= 0) then
			if forTank and scanForTank and role == "tank" then
				return true;
			end
			if forHealer and scanForHeal and role == "heal" then
				return true;
			end
			if forDamage and scanForDps and role == "dps" then
				return true;
			end
		end
end

function SatchelScan(self, event, arg)
	if event == "ADDON_LOADED" and arg == "SatchelScanner" then
		readConfig();
	end
	if running then		
		if event == "LFG_UPDATE_RANDOM_INFO" then
			if scanForTank then
				if satchelFinder("tank", 434) then
					textDatabase.tankdg1.textFrame:SetText(heroicVar[1]);
				else
					textDatabase.tankdg1.textFrame:SetText(scanVar[2]);
				end
				if satchelFinder("tank", 301) then
					textDatabase.tankdg2.textFrame:SetText(heroicVar[2]);
				else
					textDatabase.tankdg2.textFrame:SetText(scanVar[2]);
				end
				if not satchelFinder("tank", 434) and not satchelFinder("tank", 301) then
					textDatabase.tankScanningText.textFrame:SetText(classScan[2]);
					textDatabase.tankScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
				if satchelFinder("tank", 434) or satchelFinder("tank", 301) then
					satchelFound = true;
					textDatabase.tankScanningText.textFrame:SetText(classScan[3]);
					textDatabase.tankScanningText.textFrame:SetTextColor(unpack(greenColor));
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[1], ChatTypeInfo["RAID_WARNING"])
					if not MainFrame:IsShown() then
						MainFrame:Show();
					end
				end
			end
			-- Healer Scanner
			if scanForHeal then
				if satchelFinder("heal", 434) then
					textDatabase.healdg1.textFrame:SetText(heroicVar[1]);
				else
					textDatabase.healdg1.textFrame:SetText(scanVar[2]);
				end
				if satchelFinder("heal", 301) then
					textDatabase.healdg2.textFrame:SetText(heroicVar[2]);
				else
					textDatabase.healdg2.textFrame:SetText(scanVar[2]);
				end
				if not satchelFinder("heal", 434) and not satchelFinder("heal", 301) then
					textDatabase.healScanningText.textFrame:SetText(classScan[2]);
					textDatabase.healScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
				if satchelFinder("heal", 434) or satchelFinder("heal", 301) then
					satchelFound = true;
					textDatabase.healScanningText.textFrame:SetText(classScan[3]);
					textDatabase.healScanningText.textFrame:SetTextColor(unpack(greenColor));
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[2], ChatTypeInfo["RAID_WARNING"])
					if not MainFrame:IsShown() then
						MainFrame:Show();
					end
				end
			end
			-- Dps Scanner
			if scanForDps then
				if satchelFinder("dps", 434) then
					textDatabase.dpsdg1.textFrame:SetText(heroicVar[1]);
				else
					textDatabase.dpsdg1.textFrame:SetText(scanVar[2]);
				end
				if satchelFinder("dps", 301) then
					textDatabase.dpsdg2.textFrame:SetText(heroicVar[2]);
				else
					textDatabase.dpsdg2.textFrame:SetText(scanVar[2]);
				end
				if not satchelFinder("dps", 434) and not satchelFinder("dps", 301) then
					textDatabase.dpsScanningText.textFrame:SetText(classScan[2]);
					textDatabase.dpsScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
				if satchelFinder("dps", 434) or satchelFinder("dps", 301) then
					satchelFound = true;
					textDatabase.dpsScanningText.textFrame:SetText(classScan[3]);
					textDatabase.dpsScanningText.textFrame:SetTextColor(unpack(greenColor));
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[3], ChatTypeInfo["RAID_WARNING"])
					if not MainFrame:IsShown() then
						MainFrame:Show();
					end
				end
			end
			if scanForDps or scanForTank or scanForHeal then
				if not satchelFinder("tank", 434) and not satchelFinder("tank", 301) and not satchelFinder("heal", 434) and not satchelFinder("heal", 301) and not satchelFinder("dps", 434) and not satchelFinder("dps", 301) then
					satchelFound = false;
				end
			end
		end
	end
end

function savetoData()
	if scanForTankButton:GetChecked() then
		dbAdd("scanTank", true);
		scanForTank = true;
	else
		dbAdd("scanTank", false);
		scanForTank = false;
	end
	if scanForHealButton:GetChecked() then
		dbAdd("scanHeal", true);
		scanForHeal = true;
	else
		dbAdd("scanHeal", false);
		scanForHeal = false;
	end
	if scanForDpsButton:GetChecked() then
		dbAdd("scanDps", true);
		scanForDps = true;
	else
		dbAdd("scanDps", false);
		scanForDps = false;
	end
end

function uiConfig()
	SatchelScanner = {};
	SatchelScanner.panel = CreateFrame("Frame", "MyAddonPanel", UIParent );
	SatchelScanner.panel.name = "Satchel Scanner";
	InterfaceOptions_AddCategory(SatchelScanner.panel);

	SatchelScanner.childpanel = CreateFrame("Frame", "MyAddonChild", SatchelScanner.panel);
	SatchelScanner.childpanel.name = "Options";
	SatchelScanner.childpanel.parent = SatchelScanner.panel.name;
	InterfaceOptions_AddCategory(SatchelScanner.childpanel);
	SatchelScanner.panel.okay = function(self) savetoData(); end;
	
 	configurationText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	configurationText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	configurationText:SetPoint("TOPLEFT", 10, -10);
	configurationText:SetText("Configuration!");
	-- Tank CheckBox
	scanForTankButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForTankButton:SetPoint("TOPLEFT", 8, -25);
 	scanForTankText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForTankText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForTankText:SetPoint("TOPLEFT", 30, -29);
	scanForTankText:SetText("Scan for Tank Satchels");
	-- Healer CheckBox
	scanForHealButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForHealButton:SetPoint("TOPLEFT", 8, -45);
 	scanForHealText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForHealText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForHealText:SetPoint("TOPLEFT", 30, -49);
	scanForHealText:SetText("Scan for Healer Satchels");
	-- Dps CheckBox
 	scanForDpsButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForDpsButton:SetPoint("TOPLEFT", 8, -65);
 	scanForDpsText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForDpsText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForDpsText:SetPoint("TOPLEFT", 30, -69);
	scanForDpsText:SetText("Scan for Dps Satchels");
end

function drawFrames()
	uiConfig();
	MainFrame = CreateFrame("Frame", "DragFrame2", UIParent)
	MainFrame:SetMovable(true)
	MainFrame:EnableMouse(true)
	MainFrame:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" and not self.isMoving then
			self:StartMoving();
			self.isMoving = true;
		end
	end)
	MainFrame:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and self.isMoving then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetScript("OnHide", function(self)
		if ( self.isMoving ) then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetWidth(256);
	MainFrame:SetHeight(190);
	MainFrame:SetPoint("BOTTOMLEFT", 800, 400);
	MainFrame:SetFrameStrata("BACKGROUND")
	MainFrame:SetBackdrop({ 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Addons\\SatchelScanner\\border\\border.tga", tile = false, tileSize = 0, edgeSize = 8, 
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	});
	for i, frameData in pairs(frameDatabase) do
		frameData.frame = CreateFrame(frameData.Type,nil,MainFrame,frameData.inherit);
		frameData.frame:SetWidth(frameData.width);
		frameData.frame:SetHeight(frameData.height);
		frameData.frame:SetPoint(frameData.loc, frameData.x, frameData.y);
		if frameData.texture then
			frameData.textureFrame = frameData.frame:CreateTexture(frameData.name,"ARTWORK");
			frameData.textureFrame:SetTexture(frameData.location);
			frameData.textureFrame:SetAllPoints(frameData.frame);
		else
			frameData.frame:SetText(frameData.text);
			if frameData.script then
				frameData.frame:SetScript("OnClick", loadstring(frameData.functionName));
			end
		end
	end
end

function drawText() -- Draws the Text -- 
	for i, controlData in pairs(textDatabase) do
		controlData.textFrame = MainFrame:CreateFontString(nil, "OVERLAY")
		controlData.textFrame:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", controlData.fontSize, "OUTLINE");
		controlData.textFrame:SetPoint(controlData.loc, controlData.x, controlData.y);
		controlData.textFrame:SetTextColor(unpack(controlData.color));
		controlData.textFrame:SetText(controlData.text);
	end
end

-- On Load
function SatchelScanner_OnLoad(self)
	printm("Satchel Scanner v" .. addonVersion .. " Loaded!");
	printm("->> Type /ss3 for commands!");
	self:RegisterEvent("LFG_UPDATE_RANDOM_INFO")
	self:RegisterEvent("ADDON_LOADED");
	self:SetScript("OnEvent", SatchelScan)
	drawFrames();
	drawText();
	SLASH_SATCHELSCANNER1, SLASH_SATCHELSCANNER2 = "/satchelscan", "/ss3"
	SlashCmdList.SATCHELSCANNER = function(msg)
		if msg == "toggle" then
			if MainFrame:IsShown() then
				MainFrame:Hide();
				msg = ""
			else
				MainFrame:Show();
				msg = ""
			end
		elseif msg == "reset" then -- Not being used by now, will completely reset the addon to standard settings.
		elseif msg == "config" then
			InterfaceOptionsFrame_OpenToCategory(SatchelScanner.childpanel);
		else
			printm("====== Satchel Scanner ======");
			printm("->> Type '/ss3 toggle' to show/hide the frame");
			-- printm("->> Type '/ss3 reset' to reset the addon");
			printm("->> Type '/ss3 config' to configure the addon");
			msg = ""
		end
	end
end

function printm(msg)
	print("|cFFFF007F" .. msg  .. "|r");
end

-- This is the OnUpdate Function

function SatchelScanner_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	while (self.TimeSinceLastUpdate > UpdateInterval) do
		if running then
			RequestLFDPlayerLockInfo();
			if satchelFound and playSound then
				PlaySoundFile("Sound\\interface\\RaidWarning.wav", "Master")
			end
		end
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - UpdateInterval;
	end
end


